=== debian/changelog ===
obs-ptz (0.10.4-1) unstable; urgency=medium

  * Initial release. (Closes: #993897)

 -- Daniel Lenharo de Souza <lenharo@debian.org>  Thu, 10 Mar 2022 21:46:48 -0300
