=== debian/control ===
Source: obs-ptz
Section: video
Priority: optional
Maintainer: Daniel Lenharo de Souza <lenharo@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               dh-cmake,
               libdebhelper-perl,
               libobs-dev,
               libqt5serialport5-dev,
               libqt5svg5-dev,
               qtbase5-dev
Standards-Version: 4.6.0
Homepage: https://obsproject.com/forum/resources/ptz-controls.1284
Vcs-Browser: https://salsa.debian.org/debian/obs-ptz
Vcs-Git: https://salsa.debian.org/debian/obs-ptz.git
Rules-Requires-Root: no

Package: obs-ptz
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         obs-studio,
         libobs-dev,
         libqt5serialport5-dev,
         libqt5gamepad5-dev,
Description: Pan Tilt Zoom camera controls for OBS
 This plugin adds a PTZ camera control panel to OBS that can control multiple
 cameras, and can automatically change selected camera based on the currently
 active preview or program scene.
 .
 The plugin supports the VISCA serial, VISCA-over-IP, and Pelco protocols, with
 plans to add support for other camera control protocols in the future. It has
 been tested on Windows and Linux. MacOS should also work but is untested.
 .
 This is early software that isn't fully functional.
