=== debian/watch ===
version=4
https://github.com/glikely/obs-ptz/releases .*/tags/v?(\d\S+)\.tar\.(?:bz2|gz|xz)
